﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Custom View class
#Event: FileSelected (Property As String, Value As String)
'#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
'#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
'#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
Sub Class_Globals
	Private fx As JFX
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Pane
	Private tv As TableView
	Private Columns As Map
	Private TotalColumns As Int
	Type AlignEnumObject(left As String, right As String, center As String)
	Public Align As AlignEnumObject
	Type ColumnControlEnumObject(IsTextBox As String, IsLabel As String, IsImage As String, IsCombo As String, IsCheckBox As String, IsColorPicker As String, IsDatePicker As String, IsAnything As String, IsImageFilePicker As String, IsBlankProperty As String, IsFilePicker As String, IsFileNamePicker As String, IsTextArea As String)
	Public ColumnControl As ColumnControlEnumObject
	Type ColumnTypeEnumObject(IsDate As String, IsDateTime As String, IsTime As String, IsInt As String, IsBoolean As String, IsString As String, IsMoney As String, IsDouble As String, IsAnything As String)
	Public ColumnType As ColumnTypeEnumObject
	Public DateFormat As String
	Public TimeFormat As String
	Private IsReport As Boolean
	Private propWidth As String = 300
	Public PropertyBag As Map
	Private bl As List
	Private Properties As Map
	Private btnOpen As Button
	Private tfField As TextField
	Public ImagesFolder As String
	Public PropertyWidth As String = 300
	Public ValueWidth As String = 300
	Public DescriptionWidth As String = 400
	Private propertySetters As Map
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	tv.Initialize("")
	propertySetters.Initialize
	bl.Initialize 
	Properties.Initialize 
	Columns.Initialize
	tv.Items.clear 
	TotalColumns = 0
	Align.Initialize
	Align.center = "center"
	Align.left = "left"
	Align.right = "right"
	ColumnControl.Initialize
	ColumnControl.IsTextBox = "IsTextBox"
	ColumnControl.IsLabel = "IsLabel"
	ColumnControl.IsImage = "IsImage"
	ColumnControl.IsCombo = "IsCombo"
	ColumnControl.IsCheckBox = "IsCheckBox"
	ColumnControl.IsColorPicker = "IsColorPicker"
	ColumnControl.IsDatePicker = "IsDatePicker"
	ColumnControl.IsAnything = "IsAnything"
	ColumnControl.IsBlankProperty = "IsBlankProperty"
	ColumnControl.IsImageFilePicker = "IsImageFilePicker"
	ColumnControl.IsFilePicker = "IsFilePicker"
	ColumnControl.IsFileNamePicker = "IsFileNamePicker"
	ColumnControl.IsTextArea = "IsTextArea"
	ColumnType.Initialize 
	ColumnType.IsBoolean = "IsBoolean"
	ColumnType.IsDate = "IsDate"
	ColumnType.IsInt = "IsInt"
	ColumnType.IsMoney = "IsMoney"
	ColumnType.IsString = "IsString"
	ColumnType.IsDateTime = "IsDateTime"
	ColumnType.IsTime = "IsTime"
	ColumnType.IsDouble = "IsDouble"
	ColumnType.IsAnything = "IsAnything"
	DateFormat = "yyyy-MM-dd"
	TimeFormat = "HH:mm"
	DateTime.DateFormat = DateFormat
	DateTime.TimeFormat = TimeFormat
	IsReport = True  
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	Base.AddNode(tv, 0, 0, 0, 0)
	Base.Style = "-fx-border-style: none;"
	SetPropertyViewer(False)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	tv.SetLayoutAnimated(0, 0, 0, Width, Height)
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub

Sub RequestFocus
	tv.RequestFocus
End Sub

'get the property names, these are not the tags
Sub PropertyNames() As List
	Dim lst As List
	lst.Initialize 
	For Each itm As String In propertySetters.Keys
		lst.Add(itm)
	Next
	lst.Sort(True)
	Return lst
End Sub

Private Sub CInt(o As Object) As Int
  Return Floor(o)
End Sub

'''get a single property from the propertybag
Sub GetProperty(propName As String) As Object
	Dim original As String
	original = propName
	propName = propName.ToLowerCase
	If PropertyBag.ContainsKey(propName) = True Then
		Return PropertyBag.Get(propName)
	Else
		'search from property setters
		Dim lst As List
		Dim propTag As String
		lst = PropertyNames
		If lst.IndexOf(original) > 0 Then
			propTag = propertySetters.Get(original)
			Return PropertyBag.Get(propTag)
		Else	
			Log("Property " & original & " not found.")
			Return ""
		End If	
	End If
End Sub

'''set indivial property, turn bRefresh to true for a real time update
Sub SetProperty(propName As String, propValue As Object, bRefresh As Boolean)
	Dim original As String
	original = propName
	propName = propName.ToLowerCase
	If PropertyBag.ContainsKey(propName) = True Then 
		PropertyBag.Put(propName,propValue)
	Else
		' use property setters
		Dim lst As List
		Dim propTag As String
		lst = PropertyNames
		If lst.IndexOf(original) > 0 Then
			propTag = propertySetters.Get(original)
			PropertyBag.put(propTag,propValue)
		Else
			Log("Property " & propName & " not found")
			Return
		End If
	End If
	If bRefresh = True Then SetProperties
End Sub

'''Update the propertybag from a map variable
'''Useful when you read a map from a database and assign like this
Sub SetPropertyBag(nPropertyBag As Map)
	' ensure we only update those properties actually added
	Dim keyTot As Int
	Dim keyCnt As Int
	Dim keyStr As String
	Dim keyVal As Object
	keyTot = nPropertyBag.Size - 1
	For keyCnt = 0 To keyTot
		keyStr = nPropertyBag.GetKeyAt(keyCnt)
		keyVal = nPropertyBag.GetValueAt(keyCnt)
		SetProperty(keyStr,keyVal,False)
	Next
	SetProperties
End Sub

'''Update the propertybag and screen controls with
private Sub SetProperties() 
	Dim rowTot As Int
	Dim rowCnt As Int
	Dim row() As Object
	Dim itmtag As String
	Dim itmvalue As Object
	Dim itm As Object
	Dim itmType As String
	' how many rows do we have
	rowTot = tv.Items.Size - 1
	For rowCnt = 0 To rowTot
		' get the item at this row
		row = tv.Items.Get(rowCnt)
		' get control, this is in the second column
		itm = row(1)
		' get the type of the item
		itmType = GetType(itm)
		Select Case itmType
		Case "javafx.scene.control.Label"
			Dim lbl As Label
			lbl = itm
			itmtag = lbl.Tag
			' get this from map
			itmvalue = PropertyBag.Get(itmtag)
			If itmvalue = "null" Then itmvalue = ""
			lbl.text = itmvalue
		Case "javafx.scene.control.ColorPicker"
			Dim cp As ColorPicker
			cp = itm
			itmtag = cp.Tag
			' get this from map
			itmvalue = PropertyBag.Get(itmtag)
			If itmvalue = "null" Then 
				itmvalue = fx.Colors.To32Bit(fx.Colors.black)
			End If
			cp.SelectedColor = fx.Colors.From32Bit(itmvalue)
		Case "javafx.scene.control.DatePicker"
			Dim dp As DatePicker
			Dim das As Long
			dp = itm
			DateTime.DateFormat = DateFormat
			DateTime.TimeFormat = TimeFormat
			itmtag = dp.tag
			itmvalue = PropertyBag.Get(itmtag)
			If itmvalue = "null" Then itmvalue = DateTime.now
			das = DateTime.DateParse(itmvalue)
			dp.DateTicks = das
		Case "javafx.scene.control.TextField"
			Dim txt As TextField
			txt = itm
			itmtag = txt.Tag
			itmvalue = PropertyBag.Get(itmtag)
			If itmvalue = "null" Then itmvalue = ""
			txt.Text = itmvalue
		Case "javafx.scene.control.TextArea"
			Dim txt1 As TextArea
			txt1 = itm
			itmtag = txt1.Tag
			itmvalue = PropertyBag.Get(itmtag)
			If itmvalue = "null" Then itmvalue = ""
			txt1.Text = itmvalue
		Case "javafx.scene.control.CheckBox"
			Dim chk As CheckBox
			chk = itm
			itmtag = chk.tag
			itmvalue = PropertyBag.Get(itmtag)
			If itmvalue = "null" Then itmvalue = "0"
			If itmvalue = True Then
				chk.Checked = True
			Else If itmvalue = False Then
				chk.Checked = False
			else If itmvalue = "1" Then
				chk.Checked = True
			Else If itmvalue = "0" Then
				chk.Checked = False
			End If
		Case "javafx.scene.control.ComboBox"
			Dim cbo As ComboBox
			cbo = itm
			itmtag = cbo.Tag
			itmvalue = PropertyBag.Get(itmtag)
			If itmvalue = "null" Then itmvalue = ""
			cbo.Value = itmvalue
		Case "anywheresoftware.b4j.objects.PaneWrapper$ConcretePaneWrapper$NonResizePane"
			Dim pnl As Pane
			pnl = itm
			Select Case pnl.Tag
			Case "IsImageFilePicker", "IsFilePicker", "IsFileNamePicker"
				Dim pnl1 As Pane
				pnl1 = pnl.GetNode(0)
				tfField = pnl1.GetNode(0)
				itmtag = tfField.tag
				itmvalue = PropertyBag.Get(itmtag)
				If itmvalue = "null" Then itmvalue = ""
				tfField.text = itmvalue
			End Select
		End Select
	Next
End Sub

'''Get all the properties and assign to PropertyBag map
private Sub GetProperties() 
	Dim rowTot As Int
	Dim rowCnt As Int
	Dim row() As Object
	Dim itmtag As String
	Dim itmvalue As Object
	Dim itm As Object
	Dim itmType As String
	' how many rows do we have
	rowTot = tv.Items.Size - 1
	For rowCnt = 0 To rowTot
		' get the item at this row
		row = tv.Items.Get(rowCnt)
		' get control, this is in the second column
		itm = row(1)
		' get the type of the item
		itmType = GetType(itm)
		Select Case itmType
		Case "javafx.scene.control.Label"
			Dim lbl As Label
			lbl = itm
			itmtag = lbl.Tag
			itmvalue = lbl.text
			PropertyBag.Put(itmtag, itmvalue)
		Case "javafx.scene.control.ColorPicker"
			Dim cp As ColorPicker
			cp = itm
			itmtag = cp.Tag
			itmvalue = fx.Colors.To32Bit(cp.SelectedColor)
			PropertyBag.Put(itmtag, itmvalue)
		Case "javafx.scene.control.DatePicker"
			Dim dp As DatePicker
			dp = itm
			DateTime.DateFormat = DateFormat
			DateTime.TimeFormat = TimeFormat
			itmtag = dp.tag
			itmvalue = DateTime.Date(dp.DateTicks)
			PropertyBag.Put(itmtag, itmvalue)
		Case "javafx.scene.control.TextField"
			Dim txt As TextField
			txt = itm
			itmtag = txt.Tag
			itmvalue = txt.Text
			PropertyBag.Put(itmtag, itmvalue)
		Case "javafx.scene.control.TextArea"
			Dim txt1 As TextArea
			txt1 = itm
			itmtag = txt1.Tag
			itmvalue = txt1.Text
			PropertyBag.Put(itmtag, itmvalue)
		Case "javafx.scene.control.CheckBox"
			Dim chk As CheckBox
			chk = itm
			itmtag = chk.tag
			itmvalue = ChkBox2YN(chk)
			PropertyBag.Put(itmtag, itmvalue)
		Case "javafx.scene.control.ComboBox"
			Dim cbo As ComboBox
			cbo = itm
			itmtag = cbo.Tag
			itmvalue = cbo.Value
			PropertyBag.Put(itmtag, itmvalue)
		Case "anywheresoftware.b4j.objects.PaneWrapper$ConcretePaneWrapper$NonResizePane"
			Dim pnl As Pane
			pnl = itm
			Select Case pnl.Tag
			Case "IsImageFilePicker", "IsFilePicker","IsFileNamePicker"
				Dim pnl1 As Pane
				pnl1 = pnl.GetNode(0)
				tfField = pnl1.GetNode(0)
				itmtag = tfField.tag
				itmvalue = tfField.text
				PropertyBag.Put(itmtag, itmvalue)
			End Select
		End Select
	Next
End Sub

' add multiple rows at once to the tableview
Sub AddRows(rowList As List)
	If IsReport = False Then Return
	Dim rowTot As Int
	Dim rowCnt As Int
	Dim row As List
	rowTot = rowList.Size - 1
	For rowCnt = 0 To rowTot
		row = rowList.Get(rowCnt)
		AddRow(row)
	Next
End Sub

' ensure the row equals total columns
Private Sub CheckRow(rowMap As List) As Boolean
	If rowMap.Size <> TotalColumns Then
		Log("Row Error")
		Return False
	Else
		Return True
	End If
End Sub

'''Set the table view to be in property page format
Sub SetPropertyViewer(bHideDescription As Boolean)
	bl.Initialize 
	Properties.Initialize
	PropertyBag.Initialize 
	Columns.Initialize
	IsReport = True
	tv.Items.clear 
	AddColumn("Property",PropertyWidth,Align.left,True,"","",ColumnType.IsString, ColumnControl.IsLabel,"Property")
	AddColumn("Value", ValueWidth, Align.left,False,"","",ColumnType.IsAnything, ColumnControl.IsAnything,"Value")
	If bHideDescription = False Then
		AddColumn("Description", DescriptionWidth, Align.left, False,"","",ColumnType.IsString, ColumnControl.IsAnything,"Description") 
	End If
	IsReport = False
	SetColumns
End Sub

'''Set the table to be in report format
Sub SetReportViewer()
	bl.Initialize 
	Properties.Initialize 
	Columns.Initialize
	tv.Items.clear 
	IsReport = True
End Sub

'''Add label property
Sub AddLabelProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	AddProperty(propHeader,ColumnControl.IsLabel,propValue,propDescription, propTag,bl) 
End Sub

'''Add color picker property
Sub AddColorPickerProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	AddProperty(propHeader,ColumnControl.IsColorPicker,propValue,propDescription, propTag,bl) 
End Sub

'''Add date picker property
Sub AddDatePickerProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	AddProperty(propHeader,ColumnControl.IsDatePicker,propValue,propDescription, propTag,bl) 
End Sub

'''Add textbox property
Sub AddTextBoxProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	AddProperty(propHeader,ColumnControl.IsTextBox,propValue,propDescription, propTag,bl) 
End Sub

'''Add textbox property
Sub AddTextAreaProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	AddProperty(propHeader,ColumnControl.IsTextArea,propValue,propDescription, propTag,bl) 
End Sub

'''Add checkbox property
Sub AddCheckBoxProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	AddProperty(propHeader,ColumnControl.IsCheckBox, propValue,propDescription, propTag,bl) 
End Sub

'''Add combo box property
Sub AddComboBoxProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String, PropList As List)
	AddProperty(propHeader,ColumnControl.IsCombo,propValue,propDescription, propTag, PropList) 
End Sub

'''Add image file chooser property
Sub AddImageFileChooserProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	AddProperty(propHeader,ColumnControl.IsImageFilePicker,propValue,propDescription, propTag, bl) 
End Sub

Sub AddFileNameChooserProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	AddProperty(propHeader,ColumnControl.IsFileNamePicker,propValue,propDescription, propTag, bl) 
End Sub

'''Add image file chooser property
Sub AddFilePickerProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	AddProperty(propHeader,ColumnControl.IsFilePicker,propValue,propDescription, propTag, bl) 
End Sub

Private Sub ComboBoxFromList(cboBox As ComboBox, lst As List, bClear As Boolean)
	If bClear = True Then cboBox.Items.clear
	cboBox.Items.AddAll(lst) 
End Sub


Sub AddProperty(propHeader As String, propType As String, propValue As Object, propDescription As String, propTag As String, propList As List)
	If IsReport = True Then Return
	Dim nRow As List
	nRow.Initialize
	nRow.Add(propHeader)
	nRow.Add(propValue)
	nRow.Add(propDescription)
	propTag = propTag.ToLowerCase
	PropertyBag.Put(propTag, propValue)
	' ensure no duplicates
	propertySetters.Put(propHeader,propTag)
	If CheckRow(nRow) = False Then Return 
	Dim row(3) As Object
	row(0) = propHeader
	Select Case propType
	Case ColumnControl.IsTextArea
		Dim tf1 As TextArea
		tf1.Initialize("tf1")
		tf1.Text = propValue
		tf1.PrefHeight = 100
		tf1.WrapText = True
		tf1.Editable = True
		tf1.PrefWidth = propWidth
		tf1.Tag = propTag
		tf1.Style = "-fx-border-style: none;"
		row(1) = tf1
	Case ColumnControl.IsTextBox
		Dim tf As TextField
		tf.Initialize("tf")
		tf.Text = propValue
		tf.Editable = True
		tf.PrefWidth = propWidth
		tf.Tag = propTag
		tf.Style = "-fx-border-style: none;"
		row(1) = tf
	Case ColumnControl.IsLabel
		Dim lbl As Label
		lbl.Initialize("lbl")
		lbl.Text = propValue
		lbl.PrefWidth = propWidth
		lbl.Tag = propTag
		row(1) = lbl 
	Case ColumnControl.IsImage
	Case ColumnControl.IsCombo
		Dim cbo As ComboBox 
		cbo.Initialize("cbo")
		cbo.value = propValue
		cbo.PrefWidth = propWidth
		cbo.Editable = True
		cbo.Tag = propTag
		cbo.Style = "-fx-border-style: none;"
		ComboBoxFromList(cbo, propList,True)
		row(1) = cbo
	Case ColumnControl.IsCheckBox
		Dim chk As CheckBox 
		chk.Initialize("chk")
		If propValue = "1" Then
			chk.Checked = True
		Else If propValue = "0" Then
			chk.Checked = False
		Else If propValue = True Then
			chk.Checked = True
		Else If propValue = False Then
			chk.Checked = False
		End If
		chk.PrefWidth = propWidth
		chk.Tag = propTag
		chk.Style = "-fx-border-style: none;"
		'PropertyBag.Put(propTag, ChkBox2YN(chk))
		row(1) = chk 
	Case ColumnControl.IsColorPicker
		Dim cp As ColorPicker
		cp.Initialize("cp")
		cp.SelectedColor = propValue
		cp.PrefWidth = propWidth
		cp.Tag = propTag
		cp.Style = "-fx-border-style: none;"
		row(1) = cp
	Case ColumnControl.IsDatePicker
		Dim das As Long
		Dim dd As String
		Dim dp As DatePicker
		dp.Initialize("dp")
		dp.DateFormat = DateFormat
		dd = propValue
		dd = dd.trim
		If dd.Length > 0 Then 
			das = DateTime.DateParse(dd)
			dp.DateTicks = das
		End If
		dp.PrefWidth = propWidth
		dp.Tag = propTag
		dp.Style = "-fx-border-style: none;"
		row(1) = dp 
	Case ColumnControl.IsImageFilePicker, ColumnControl.IsFileNamePicker, ColumnControl.IsFilePicker
		' define a new pane
		Dim mBase As Pane
		mBase.Initialize("mBase")
		' load the file selector layout
		mBase.LoadLayout("vFileSelector")
		' set the border to none
		mBase.Style = "-fx-border-style: none;"
		mBase.Tag = propType
		' get the parent panel
		Dim pnl As Pane = mBase.GetNode(0)
		pnl.Tag = propType
		mBase.PrefHeight = 30dip
		pnl.PrefHeight = 30dip
		' define the controls inside the panel
		' get the panels
		tfField = pnl.GetNode(0)
		btnOpen = pnl.GetNode(1)
		' set the background image
		CSSUtils.SetBackgroundImage(btnOpen, File.DirAssets, "open.png")
		tfField.Tag = propTag
		tfField.TooltipText = "Select a File"
		tfField.PromptText = "Select a File"
		tfField.Text = propValue
		btnOpen.Tag = mBase
		row(1) = mBase
	End Select
	row(2) = propDescription
	tv.Items.Add(row)
End Sub

Sub AddRow(rowMap As List)
	If IsReport = False Then Return
	If CheckRow(rowMap) = False Then Return
	Dim mSize As Int
	Dim mCnt As Int
	Dim ColDef As Map
	Dim ColAlign As String
	Dim ColTextColor As String
	Dim ColType As String
	Dim ColControl As String
	Dim ColBackColor As String
	Dim ColName As String
	Dim ColTag As String
	mSize = rowMap.size - 1
	Dim row(rowMap.size) As Object
	For mCnt = 0 To mSize
		ColDef = Columns.GetValueAt(mCnt)
		ColName = ColDef.Get("name")
		ColName = ColName.Replace(" ","").trim
		ColAlign = ColDef.Get("align")
		ColTextColor = ColDef.Get("textcolor")
		ColBackColor = ColDef.Get("backcolor")
		ColType = ColDef.Get("coltype")
		ColControl = ColDef.Get("colcontrol")
		ColTag = ColDef.Get("tag")
		Select Case ColControl
		Case ColumnControl.IsTextBox
			Dim tf As TextField
			tf.Initialize("tf")
			tf.Text = rowMap.Get(mCnt)
			tf.Tag = ColTag
			tf.Editable = True
			row(mCnt) = tf
		Case ColumnControl.IsLabel = "IsLabel"
			Dim lbl As Label
			lbl.Initialize("lbl")
			lbl.Text = rowMap.Get(mCnt)
			lbl.Tag = ColTag
			row(mCnt) = lbl 
		Case ColumnControl.IsImage
		Case ColumnControl.IsCombo
			Dim cbo As ComboBox 
			cbo.Initialize("cbo")
			cbo.value = rowMap.Get(mCnt)
			cbo.Tag = ColTag
			row(mCnt) = cbo 
		Case ColumnControl.IsCheckBox
			Dim chk As CheckBox 
			chk.Initialize("chk")
			If rowMap.get(mCnt) = "1" Then
				chk.Checked = True
			Else If rowMap.Get(mCnt) = "0" Then
				chk.Checked = False
			Else If rowMap.Get(mCnt) = True Then
				chk.Checked = True
			Else If rowMap.Get(mCnt) = False Then
				chk.Checked = False
			End If
			chk.Tag = ColTag
			row(mCnt) = chk 
		Case ColumnControl.IsColorPicker
			Dim cp As ColorPicker
			cp.Initialize("cp")
			cp.SelectedColor = rowMap.Get(mCnt)
			cp.Tag = ColTag 
			row(mCnt) = cp
		Case ColumnControl.IsDatePicker
			Dim das As Long
			Dim dd As String
			Dim dp As DatePicker
			dp.Initialize("dp")
			dp.DateFormat = DateFormat
			dd = rowMap.Get(mCnt)
			dd = dd.trim
			If dd.Length > 0 Then 
				das = DateTime.DateParse(dd)
				dp.DateTicks = das
			End If
			dp.Tag = ColTag
			row(mCnt) = dp 
		End Select
	Next
	tv.Items.Add(row)
End Sub

'''Add a column to the TableView
Sub AddColumn(colName As String, colWidth As String, AlignEnum As String, colSortable As Boolean, colBackColor As String, colTextColor As String, ColumnTypeEnum As String, ColumnControlEnum As String, ColumnTag As String)
	If IsReport = False Then Return
	Dim m As Map
	m.Initialize
	m.Put("name", colName)
	m.Put("width", colWidth)
	m.Put("align", AlignEnum)
	m.Put("sortable", colSortable)
	m.Put("backcolor", colBackColor)
	m.Put("textcolor", colTextColor)
	m.Put("coltype", ColumnTypeEnum)
	m.Put("colcontrol", ColumnControlEnum)
	m.Put("tag", ColumnTag)
	m.Put("visible", True)
	Columns.Put(colName, m)
End Sub

'Hide the description column and refresh the columns
Sub HideDescriptionColumn
	HideColumn("Description",True)
End Sub

'''Hide a column from being shown
Sub HideColumn(colName As String, bRefresh As Boolean)
	If Columns.ContainsKey(colName) = False Then
		Log("HideColumn: " & colName & " does not exist")
		Return
	End If
	Dim m As Map
	m = Columns.Get(colName)
	m.Put("visible", False)
	Log("HideColumn: " & colName & " will be hidden")
	If bRefresh = True Then SetColumns
End Sub

'Refresh the columns after hiding some columns with HideColumn method
Sub RefreshColumns
	SetColumns
End Sub

'''Add a color picker column
Sub AddColorPicker(ColName As String, colTag As String)
	AddColumn(ColName,-1,Align.left,True,"","",ColumnType.IsString, ColumnControl.IsColorPicker, colTag)
End Sub

'''Add a date picker column
Sub AddDatePicker(ColName As String, colTag As String)
	AddColumn(ColName,-1,Align.left,True,"","",ColumnType.IsString, ColumnControl.Isdatepicker, colTag)
End Sub

'''Add a textbox that is left aligned and sortable
Sub AddTextBoxLeftAlignSortable(colName As String, colTag As String)
	AddTextBox(colName,Align.left,True, colTag)
End Sub


'''Add a textbox column that is right aligned and sortable
Sub AddTextBoxRightAlignSortable(colName As String, colTag As String)
	AddTextBox(colName,Align.right,True, colTag)
End Sub

'''Add a combobox column
Sub AddComboBox(colName As String, colTag As String)
	AddColumn(colName,-1,Align.left,False,"","",ColumnType.IsString, ColumnControl.IsCombo, colTag)  
End Sub

'''Add a textbox column
Sub AddTextBox(colName As String, AlignEnum As String, colSortable As Boolean, colTag As String)
	AddColumn(colName,-1,AlignEnum,colSortable,"","",ColumnType.IsString,ColumnControl.IsTextBox, colTag)  	
End Sub

'''Add a checkbox column
Sub AddCheckBox(colName As String, colTag As String)
	AddColumn(colName,-1,Align.left,False,"","",ColumnType.IsBoolean, ColumnControl.IsCheckBox, colTag)
End Sub

'''Set columns based on definitions
private Sub SetColumns
	TotalColumns = Columns.Size
	Dim colTot As Int
	Dim colCnt As Int
	Dim colPos As Int
	Dim colNames As List
	Dim colName As String
	Dim colMap As Map
	Dim colWidth As String
	Dim colAlign As String
	Dim colSortable As Boolean
	Dim colBackColor As String
	Dim colTextColor As String
	Dim colVisible As Boolean
	colNames.Initialize
	colTot = Columns.Size - 1
	' get column names
	For colCnt = 0 To colTot
		colMap = Columns.GetValueAt(colCnt)
		colName = colMap.get("name")
		colNames.Add(colName)
	Next
	' set the column names 
	tv.SetColumns(colNames)
	' set other column attributes
	colTot = Columns.Size - 1
	' get column names
	For colCnt = 0 To colTot
		colMap = Columns.GetValueAt(colCnt)
		colWidth = colMap.get("width")
		colAlign = colMap.get("align")
		colSortable = colMap.get("sortable")
		colVisible = colMap.Get("visible")
		' set columns that are sortable
		tv.SetColumnSortable(colCnt,colSortable)
		' set columns widths, default is 150
		If colWidth = "-1" Then colWidth = 150
		tv.SetColumnWidth(colCnt,colWidth)
		' set visible columns
		tv.SetColumnVisible(colCnt,colVisible)
	Next
	
	'If intWrapHeader = True Then
	'	SetTableHeaderWrap(intTV, intHeaderHeight)
	'End If
	' update backcolor per heading and alignment
	'Dim joTV As JavaObject = intTV
	'Dim colCnt As Int = -1
	'Dim HeaderRow As Pane = joTV.RunMethod("lookup",Array("TableHeaderRow"))
    'For Each N As JavaObject In HeaderRow.GetAllViewsRecursive
     '   If N Is Label Then
     '       colCnt = colCnt + 1
	'	    colMap = Columns.GetKeyAt(colCnt)
	'	    colAlign = colMap.get("align")
	'		colBackColor = colMap.Get("backcolor")
	'		colTextColor = colMap.Get("textcolor")
	'		Dim NL As Label = N
	'		'Seems to lose the text centering
     '       Select Case colAlign
	'		Case Align.center
	'			CSSUtils.SetStyleProperty(NL,"-fx-text-alignment","center")
	'		Case Align.left
	'			CSSUtils.SetStyleProperty(NL,"-fx-text-alignment","left")
	'		Case Align.right
	'			CSSUtils.SetStyleProperty(NL,"-fx-text-alignment","right")
	'		End Select
	'		'If colBackColor <> Null Then CSSUtils.SetBackgroundColor(NL, colBackColor) 
    '    End If
    'Next
End Sub

'''Get Updates Property Bag
Sub GetPropertyBag() As Map
	GetProperties
	Return PropertyBag
End Sub

'''Refresh the properties
Sub RefreshProperties
	SetProperties
End Sub

private Sub ReplaceNull(Target As String) As String
	If Target = Null Or Target= "null" Then 
		Return ""
	Else
		Return Target
	End If
End Sub

private Sub GetColumns() As List
	Dim colList As List
	Dim colTot As Int
	Dim colCnt As Int
	Dim colStr As String
	colList.Initialize 
	colTot = tv.ColumnsCount - 1
	For colCnt = 0 To colTot
		colStr = tv.GetColumnHeader(colCnt)
		colList.Add(colStr) 
	Next
	Return colList
End Sub


private Sub ChkBox2YN(chkBox As CheckBox) As String
	If chkBox.Checked = True Then
		Return "1"
	Else
		Return "0"
	End If
End Sub


'Description: Set checkbox value based on numeric 0/1
'Tag: checkbox, numeric
private Sub YN2ChkBox(YN As String, chkBox As CheckBox)
	Select Case YN
	Case "1"
		chkBox.Checked = True
	Case Else
		chkBox.Checked = False
	End Select
End Sub

Private Sub btnOpen_Action
	Dim btn As Button
	Dim imgFile As String
	btn = Sender
	Dim pnl As Pane
	pnl = btn.Tag
	Dim pnl1 As Pane
	pnl1 = pnl.GetNode(0)
	tfField = pnl1.GetNode(0)
	Dim fc As FileChooser
	Dim fileSelected As String			'File selected. If selected full path is returned else ""
  	fc.Initialize                       'Init! Do not forget
	Select Case pnl.Tag
	Case ColumnControl.IsImageFilePicker
		fc.Title = "Select an Image File"
  		fc.InitialDirectory = ImagesFolder
  	Case ColumnControl.IsFilePicker, ColumnControl.IsFileNamePicker
		fc.Title = "Select a File"
  		fc.InitialDirectory = ImagesFolder
  	Case Else
		fc.Title = "Select a File"
  		fc.InitialDirectory = File.DirApp   'Set starting folder
	End Select
	fileSelected = fc.ShowOpen(CallBack)  	'Show the dialog and select
	If fileSelected.Length > 0 Then 
		' extract the last part of the file
		Select Case pnl.Tag
		Case ColumnControl.IsImageFilePicker
			'specific for abmaterial usage
			imgFile = fileSelected
			imgFile = File.GetName(imgFile)
			tfField.Text = "../images/" & imgFile
		Case ColumnControl.IsFileNamePicker
			imgFile = fileSelected
			imgFile = File.GetName(imgFile)
			tfField.Text = imgFile
		Case Else
			tfField.Text = fileSelected
		End Select
	End If
	If SubExists(CallBack, EventName & "_FileSelected") Then
		CallSub3(CallBack, EventName & "_FileSelected", tfField.Tag, tfField.text)
	End If
End Sub